* [PATCH 3/3] xfstests: introduce xfs/324 to verify turn group/project quota off along with fsstress
@ 2013-11-29 7:03 Jeff Liu
2013-12-03 0:53 ` Dave Chinner
0 siblings, 1 reply; 3+ messages in thread
From: Jeff Liu @ 2013-11-29 7:03 UTC (permalink / raw)
To: xfs@oss.sgi.com
From: Jie Liu <jeff.liu@oracle.com>
Introduce xfs/324 to verify that we can turn group/project quotas off
while user quota is on and fsstress is running.
Signed-off-by: Jie Liu <jeff.liu@oracle.com>
---
tests/xfs/324 | 89 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/xfs/324.out | 7 +++++
tests/xfs/group | 1 +
3 files changed, 97 insertions(+)
create mode 100755 tests/xfs/324
create mode 100644 tests/xfs/324.out
diff --git a/tests/xfs/324 b/tests/xfs/324
new file mode 100755
index 0000000..98f5f73
--- /dev/null
+++ b/tests/xfs/324
@@ -0,0 +1,89 @@
+#! /bin/bash
+# FS QA Test No. 324
+#
+# Test to verify that turn group/project quotas off while fstress and
+# user quotas are left on.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Oracle, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# Modify as appropriate.
+_supported_fs xfs
+_supported_os Linux
+
+_require_scratch
+_require_xfs_quota
+_require_xfs_crc_sb
+
+_qmount_option "uquota,gquota,pquota"
+
+STRESS_DIR=$SCRATCH_MNT/testdir
+
+_exercise()
+{
+ type=$1
+
+ _qmount
+ mkdir -p $STRESS_DIR
+
+ $FSSTRESS_PROG -d $STRESS_DIR -n 100 -p 1000 $FSSTRESS_AVOID >>/dev/null 2>&1 &
+
+ xfs_quota -x -c "off -$type" $SCRATCH_DEV
+
+ killall -q $FSSTRESS_PROG
+ wait
+
+ rm -rf $STRESS_DIR
+ umount $SCRATCH_MNT
+}
+
+echo "*** turn off group quotas"
+_exercise g
+echo "*** done"
+
+echo "*** turn off project quotas"
+_exercise p
+echo "*** done"
+
+echo "*** turn off group/project quotas"
+_exercise gp
+echo "*** done"
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/324.out b/tests/xfs/324.out
new file mode 100644
index 0000000..0f67d93
--- /dev/null
+++ b/tests/xfs/324.out
@@ -0,0 +1,7 @@
+QA output created by 324
+*** turn off group quotas
+*** done
+*** turn off project quotas
+*** done
+*** turn off group/project quotas
+*** done
diff --git a/tests/xfs/group b/tests/xfs/group
index b420e12..b0aa5df 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -184,3 +184,4 @@
302 auto dump
322 auto quick quota
323 auto quick quota
+324 auto quota
--
1.8.3.2
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
^ permalink raw reply related [flat|nested] 3+ messages in thread
* Re: [PATCH 3/3] xfstests: introduce xfs/324 to verify turn group/project quota off along with fsstress
2013-11-29 7:03 [PATCH 3/3] xfstests: introduce xfs/324 to verify turn group/project quota off along with fsstress Jeff Liu
@ 2013-12-03 0:53 ` Dave Chinner
2013-12-03 7:36 ` Jeff Liu
0 siblings, 1 reply; 3+ messages in thread
From: Dave Chinner @ 2013-12-03 0:53 UTC (permalink / raw)
To: Jeff Liu; +Cc: xfs@oss.sgi.com
On Fri, Nov 29, 2013 at 03:03:39PM +0800, Jeff Liu wrote:
> From: Jie Liu <jeff.liu@oracle.com>
>
> Introduce xfs/324 to verify that we can turn group/project quotas off
> while user quota is on and fsstress is running.
>
> Signed-off-by: Jie Liu <jeff.liu@oracle.com>
....
> +
> +# Modify as appropriate.
> +_supported_fs xfs
> +_supported_os Linux
> +
> +_require_scratch
> +_require_xfs_quota
> +_require_xfs_crc_sb
Hmmm, now that I look at the way you are using _require_xfs_crc_sb,
it's broken. The scratch device is in an undefined state until a
test runs _scratch_mkfs on it.
What you need to do is check whether mkfs supports "-m crc=1", and
then mkfs the scratch device with that option set.
> +
> +_qmount_option "uquota,gquota,pquota"
> +
> +STRESS_DIR=$SCRATCH_MNT/testdir
> +
Where do you mkfs the scratch device?
> +_exercise()
> +{
> + type=$1
> +
> + _qmount
> + mkdir -p $STRESS_DIR
> +
> + $FSSTRESS_PROG -d $STRESS_DIR -n 100 -p 1000 $FSSTRESS_AVOID >>/dev/null 2>&1 &
There's no real reason for creating a load of 1000 processes here.
Half of them won't even get started before this:
> + xfs_quota -x -c "off -$type" $SCRATCH_DEV
is run.
> + killall -q $FSSTRESS_PROG
> + wait
and then you kill them straight away.
> + rm -rf $STRESS_DIR
> + umount $SCRATCH_MNT
You don't need this if you just scratch_mkfs the device between
tests.
So, wouldn't it be better to do:
scratch_mkfs -m crc=1
_qmount
mkdir -p $STRESS_DIR
$FSSTRESS_PROG -d $STRESS_DIR -n 1000 -p 100 $FSSTRESS_AVOID >>/dev/null 2>&1 &
sleep 10
xfs_quota -x -c "off -$type" $SCRATCH_DEV
sleep 5
killall -q $FSSTRESS_PROG
wait
Cheers,
Dave.
--
Dave Chinner
david@fromorbit.com
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
^ permalink raw reply [flat|nested] 3+ messages in thread
* Re: [PATCH 3/3] xfstests: introduce xfs/324 to verify turn group/project quota off along with fsstress
2013-12-03 0:53 ` Dave Chinner
@ 2013-12-03 7:36 ` Jeff Liu
0 siblings, 0 replies; 3+ messages in thread
From: Jeff Liu @ 2013-12-03 7:36 UTC (permalink / raw)
To: Dave Chinner; +Cc: xfs@oss.sgi.com
On 12/03 2013 08:53 AM, Dave Chinner wrote:
> On Fri, Nov 29, 2013 at 03:03:39PM +0800, Jeff Liu wrote:
>> From: Jie Liu <jeff.liu@oracle.com>
>>
>> Introduce xfs/324 to verify that we can turn group/project quotas off
>> while user quota is on and fsstress is running.
>>
>> Signed-off-by: Jie Liu <jeff.liu@oracle.com>
> ....
>> +
>> +# Modify as appropriate.
>> +_supported_fs xfs
>> +_supported_os Linux
>> +
>> +_require_scratch
>> +_require_xfs_quota
>> +_require_xfs_crc_sb
>
> Hmmm, now that I look at the way you are using _require_xfs_crc_sb,
> it's broken. The scratch device is in an undefined state until a
> test runs _scratch_mkfs on it.
>
> What you need to do is check whether mkfs supports "-m crc=1", and
> then mkfs the scratch device with that option set.
Got it.
>
>> +
>> +_qmount_option "uquota,gquota,pquota"
>> +
>> +STRESS_DIR=$SCRATCH_MNT/testdir
>> +
>
> Where do you mkfs the scratch device?
Oops, this problem must be concealed as it has ran against the environment
from previous test.
>
>> +_exercise()
>> +{
>> + type=$1
>> +
>> + _qmount
>> + mkdir -p $STRESS_DIR
>> +
>> + $FSSTRESS_PROG -d $STRESS_DIR -n 100 -p 1000 $FSSTRESS_AVOID >>/dev/null 2>&1 &
>
> There's no real reason for creating a load of 1000 processes here.
> Half of them won't even get started before this:
>
>> + xfs_quota -x -c "off -$type" $SCRATCH_DEV
>
> is run.
>
>> + killall -q $FSSTRESS_PROG
>> + wait
>
> and then you kill them straight away.
>
>> + rm -rf $STRESS_DIR
>> + umount $SCRATCH_MNT
>
> You don't need this if you just scratch_mkfs the device between
> tests.
>
> So, wouldn't it be better to do:
>
> scratch_mkfs -m crc=1
> _qmount
> mkdir -p $STRESS_DIR
> $FSSTRESS_PROG -d $STRESS_DIR -n 1000 -p 100 $FSSTRESS_AVOID >>/dev/null 2>&1 &
> sleep 10
> xfs_quota -x -c "off -$type" $SCRATCH_DEV
> sleep 5
> killall -q $FSSTRESS_PROG
> wait
Above problems will be fixed in next round of post.
Thanks,
-Jeff
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
^ permalink raw reply [flat|nested] 3+ messages in thread
end of thread, other threads:[~2013-12-03 7:36 UTC | newest]
Thread overview: 3+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2013-11-29 7:03 [PATCH 3/3] xfstests: introduce xfs/324 to verify turn group/project quota off along with fsstress Jeff Liu
2013-12-03 0:53 ` Dave Chinner
2013-12-03 7:36 ` Jeff Liu
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox